<?

require_once('lib/misc.php');
require_once('lib/database.php');

$word = misc_getParam('word');
$g_maxLen = 40;
$g_storyId = 1;

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; CHARSET=UTF-8" />
    <meta name="robots" content="noindex,nofollow,noarchive" />
    <title>Story Words</title>
    <link rel="stylesheet" href="default.css" type="text/css" media="screen,projection,print" />
</head>
<body>

<div class="content">
<? handleAll($word); ?>
</div>

</body>
</html><?

function handleAll($word)
{
    global $g_maxLen;

    $db = openDatabase();

    if ( trim($word) != '' ) { submitWord($word); }
    
    // Enter your own first part here:
    echo '<p>&#8220;<strong>When Alison entered the room, she</strong> ' . getStory() . ' <strong>______</strong>&#8221;</p>';

    ?><form action="./" method="post"><p>
    <a href="/archive/2006-11-24-n28.html" target="_top">Refresh</a> the story, then add your next word:<br />
    <!-- <strong><em>Thanks for participating! Submissions have ended now.</em></strong> -->
    <input type="text" name="word" style="width: 220px" maxlen="<?= misc_toAttribute($g_maxLen) ?>" />
    <input type="submit" value="Add it" />
    </p>
    <p style="color: #777">PS: I'll adjust grammar when needed.</p>
    <p style="color: #777">PPS: <?= misc_toXml( number_format( getIpCount() ) ) ?> people have written the story so far.</p>
    </form>

    <?

    closeDatabase($db);
}

function getStory()
{
    global $g_storyId;

    $s = '';
    $lastWord = '';
    $query = 'SELECT word FROM story_words WHERE storyId = ' . smartQuote($g_storyId) . ' ORDER BY dateCreated ASC';
    $rows = mysql_query($query) or die( '<!-- Error: ' . mysql_error() . ' -->' );
    while ( $c = mysql_fetch_array($rows) ) {
        if ( !isBlacklisted($c['word']) ) {
            if ($lastWord != $c['word']) {
                $s .= ' ' . $c['word'];
            }
            $lastWord = $c['word'];
        }
    }

    $s = str_replace(' .', '.', $s);
    $s = str_replace(' ,', ',', $s);

    $s = misc_toXml($s);

    $s = str_replace(' -- ', ' &#8211; ', $s);
    // Use "^r" as break character (you might wanna
    // disallow this from actual user input, so you can only enter it in the table)
    $s = str_replace('^r', '<br />', $s);

    return $s;
}

function submitWord($word)
{
    global $g_maxLen;
    global $g_storyId;

    $word = trim($word);
    $ip = misc_getIp();

    if ( strpos($word, ' ') !== false ) {
        echo '<p class="error">Ooops: please only use single words to add...</p>';
    }
    else if ( strlen($word) > $g_maxLen ) {
        echo '<p class="error">Ooops: please use smaller words...</p>';
    }
    else if ( ipExistsLately($ip) ) {
        echo '<p class="error">Ooops: please give others a chance to add some words first, and try again later...</p>';
    }
    else {
        $dateCreated = getIsoDate();
        $query = 'INSERT INTO story_words (storyId, word, ip, dateCreated) ' .
                'VALUES (' . smartQuote($g_storyId) . ', ' . smartQuote($word) . ', ' . smartQuote($ip) . ', ' . smartQuote($dateCreated) . ')';
        $rows = mysql_query($query) or die( '<!-- Error: ' . mysql_error() . ' -->' );
        echo '<p class="footnote">(Thanks, word submitted.)</p>';
    }
}

function ipExistsLately($ip)
{
    global $g_storyId;

    $query = 'SELECT ip FROM story_words WHERE storyId = ' . smartQuote($g_storyId) . ' ORDER BY dateCreated DESC LIMIT 8';
    $rows = mysql_query($query) or die( '<!-- Error: ' . mysql_error() . ' -->' );
    $isIn = false;
    while ( $c = mysql_fetch_array($rows) ) {
        if ($c['ip'] == $ip) {
            $isIn = true;
            break;
        }
    }
    return $isIn;

}

function isBlacklisted($word)
{
    $blacklist = array('fuck', 'shit', 'asshole', 'bitch'); // add your own curse words here
    $isUrl = stripos($word, '.com') !== false || stripos($word, 'www.') !== false || stripos($word, 'http://') !== false;
    return in_array( strtolower($word), $blacklist ) || $isUrl;
}

function getIpCount()
{
    global $g_storyId;
    $query = 'SELECT DISTINCT ip FROM story_words WHERE storyId = ' . smartQuote($g_storyId);
    $rows = mysql_query($query) or die( '<!-- Error: ' . mysql_error() . ' -->' );
    $v = mysql_num_rows($rows);
    return $v;
}

?>